/******************************************************************************
	hCount for use with the new Tilted Time Windows with Subtraction
	01-NOV-2007
******************************************************************************/

#ifndef __HCSUB_
#define	__HCSUB_

#define WINDOWS	15
#define	INSERT	1
#define DELETE	-1

#ifndef random:
#define random(v1,v2) (((double)(v1))+(((double)(v2)-((double)(v1)))*rand()/(RAND_MAX+1.0f)))
#endif


typedef struct hcTiti {
	int c[WINDOWS];
} TS_TYPE;


typedef struct hc_type {
    long N;			// current transaction number
    TS_TYPE **S;		// S[m][h] hash tables 
    int m, h;		// dimensions of the hash table array S 
    int *a, *b;		// a_i and b_i -> array of h random numbers 
    int P;			// the prime number used by the hashing function 
    long M;			// largest number in data stream 
} hc_type;

extern void hc_print(hc_type * hc, int id);
extern hc_type *hc_init(float rho, float epsilon, long M);
extern void hc_update(hc_type *, int, int);
extern void hc_destroy(hc_type *);
extern int hc_size(hc_type *);
extern void hc_shift(hc_type *hc);
extern long hc_query(hc_type *, int, long);

#endif
