/******************************************************************************
	hCount for use with the new Tilted Time Windows with Subtraction
	01-NOV-2007
******************************************************************************/

#ifndef __HISTOGRAM_HCSUB_
#define	__HISTOGRAM_HCSUB_

#define WINDOWS	15
#define	INSERT	1
#define DELETE	-1

// macro that returns a random number in [v1, v2) 
#define random(v1,v2) (((double)(v1))+(((double)(v2)-((double)(v1)))*rand()/(RAND_MAX+1.0f)))


typedef struct { // same struct for all configurations. depending on configuration, we limit it.
    int f1;
    int f2;
    int f3;
    int f4;
    int f5;
    int f6;
    int f7;
    int f8;
//    unsigned int f1: 2;
//    unsigned int f2: 2;
//    unsigned int f3: 2;
//    unsigned int f4: 2;
} histogram_struct;

typedef struct histogram_hcTiti {
        int c[WINDOWS+4];
        histogram_struct histogram[WINDOWS];
} HISTOGRAM_TS_TYPE;


typedef struct histogram_hc_type {
    long N;			// current transaction number
    HISTOGRAM_TS_TYPE **S;		// S[m][h] hash tables
    int m, h;		// dimensions of the hash table array S
    int *a, *b;		// a_i and b_i -> array of h random numbers 
    int P;			// the prime number used by the hashing function 
    long M;			// largest number in data stream 
} histogram_hc_type;

extern histogram_hc_type *histogram_hc_init(double rho, double epsilon, long M);
extern void histogram_hc_update(histogram_hc_type *, int, int);
extern void histogram_hc_destroy(histogram_hc_type *);
extern void histogram_hc_shift(histogram_hc_type *hc);
extern long histogram_hc_query(histogram_hc_type *, int, long);

#endif
