

#ifndef __LINEAR_
#define	__LINEAR_

#define LWINDOWS	1100
#define	INSERT	1
#define DELETE	-1

#define TRUE	1
#define FALSE	0

// macro that returns a random number in [v1, v2) 
#define random(v1,v2) (((double)(v1))+(((double)(v2)-((double)(v1)))*rand()/(RAND_MAX+1.0f)))

typedef struct linear {
	int c[LWINDOWS];
} SL_TYPE;

typedef struct linear_type {
    long N;			// current transaction number
    SL_TYPE **S;		// S[m][h] hash tables 
    int m, h;		// dimensions of the hash table array S 
    int *a, *b;		// a_i and b_i -> array of h random numbers 
    int P;			// the prime number used by the hashing function 
    long M;			// largest number in data stream 
} linear_type;

extern void linear_print(linear_type * hc, int id);
extern linear_type *linear_init(double rho, double epsilon, long M);
extern void linear_update(linear_type *, int, int);
extern void linear_destroy(linear_type *);
extern int linear_size(linear_type *);
extern long linear_query(linear_type *hc, long start, long end, long val);


#endif
